<?
	// This file is copyright 2000-2001 xmedia srl
	// http://www.xmedia.net/

	class Domain {
		var $name;
		var $user;

		var $aliasOf;

		var $quota_data;

		function Domain() {
			$this->quota_data = new QuotaData();
		}

		function Domain($name, $user, $aliasOf = "") {
			$this->name = $name;
			$this->user = $user;

			$this->quota_data = new QuotaData();

			if(aliasOf != "")
				$this->aliasOf = $aliasOf;
			else
				$this->aliasOf = "";
		}

		function getname() {
			return $this->name;
		}

		function getuser() {
			return $this->user;
		}

		function isAlias() {
			return($this->aliasOf != "");
		}

		function getAliasOf() {
			return $this->aliasOf;
		}

		function setquotadefaults() {
			return $this->readquotadata(QUOTA_FILE, "default");
		}

		function setaliasquotavalues() {
			$this->quota_data->setValuesforAlias();
		}

		function readquotadata($file = QUOTA_FILE, $name = "") {
			if($name == "")
				$name = $this->name;

			$f = @file($file);
			if(! is_array($f))
				return false;

			$linenum = 0;

			while(list($i, $line) = each($f)) {
				if(substr($line, $name, strlen($name)) == $name) {
					$linenum = $i;
					break;
				}
			}

			if(! $linenum)
				return false;

			$this->quota_data->read($line);
			return true;
		}

		function deletequotadata($file = QUOTA_FILE) {
			$this->writequotadata($file, true);
		}

		function writequotadata($file = QUOTA_FILE, $delete = false) {
			$linenum = 0;
			$f = @file($file);

			$str = $this->name . "|" . $this->quota_data->format() . "|\n";

			if(! is_array($f))
				$f = array();

			// Controllo se il dominio e` gia` nel file
			while(list($i, $line) = each($f)) {
				$linestart = substr($line, 0, strlen($this->name));
				if($linestart == $this->name) {
					$linenum = $i;  // Trovato
					break;
				}
			}

			if($linenum == 0) {
				$f[] = $str;
				$linenum = key($f);
			}
			else
				$f[$linenum] = $str;

			$fp = @fopen($file, "w");
			if(! fp)
				return false;

			$count = count($f);

			if(! $delete)
				for($i = 0; $i < $count; $i++)
					@fputs($fp, $f[$i]);
			else
				for($i = 0; $i < $count; $i++)
					if($i != $linenum)
						@fputs($fp, $f[$i]);
			@fclose($fp);

			return true;
		}
	}
?>
